#include "common.h"

extern char *command_name;
extern char *version_string;


void
usage (void)
{
  fprintf (stderr, "%s version %s\n\
- dos <-> unix text converter\n\
\n\
usage: %s [FILE]\n\
\n\
--version  show version\n\
--help     print this help\n", command_name, version_string, command_name);

  exit (1);
}


void
error (char *filename, char *msg)
{
  fprintf (stderr, "%s: %s: %s\n", command_name, filename, msg);
}


int
isdir (char *filename)
{
  /* check whether file is directory */

  struct stat buf;

  stat (filename, &buf);
  if (S_ISDIR (buf.st_mode))
    return DIR;
  else
    return NOTDIR;
}


int
check_text (char *filename)
{
  FILE *fp;
  char buffer[BUFSIZ];
  int lines = 0, cr = 0;

  /* check whether file is dos-text or unix-text */
  if ((fp = fopen (filename, "r")) == NULL)
    {
      error (filename, strerror (errno));
      exit (1);
    }

  while (fgets (buffer, BUFSIZ, fp) != NULL)
    {
      lines++;
      if (buffer[strlen (buffer) - 2] == CRTL_M)
	cr++;
    }
  fclose (fp);

  if (lines == cr)
    return DOSTEXT;
  else if (cr == 0)
    return UNIXTEXT;
  else
    return MIXEDTEXT;
}
